#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=print4mi.ico
#AutoIt3Wrapper_Outfile=print4mi.exe
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Comment=     MapInfo
#AutoIt3Wrapper_Res_Description=  MapInfo
#AutoIt3Wrapper_Res_Fileversion=1.0.0.3
#AutoIt3Wrapper_Res_LegalCopyright=Ciril V. Golubev
#AutoIt3Wrapper_Res_Language=1049
#AutoIt3Wrapper_Res_Field=WebSite|http://glab2007.narod.ru
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <Array.au3>
#include <RecFileListToArray.au3>

If Msgbox(4 + 64,"PrintAllReports For MapInfo", "    " & @CRLF & _
 "     " & @CRLF & _
 "    ." & @CRLF & _
 "  ?", 0) = 7 Then Exit

$sRoot = FileSelectFolder("  ", "")
If @error Then
   MsgBox (16,": " & Hex(@error, 8),"  !", 5)
   Exit
EndIf

$aWor = _RecFileListToArray($sRoot, "*.wor", 1, 1, 0, 2)

ProgressOn("   MapInfo", "  :", "0 ")
$progress = 100 / (UBound($aWor) - 1)

$oMI = ObjCreate("MapInfo.Application")
if @error then
   Msgbox(16,": " & Hex(@error, 8),"  !", 5)
   Exit
EndIf
$oMI.Visible = True
;$oMI.Do ("Note ""I'm ready!""")

For $i = 1 To UBound($aWor) - 1
$oMI.Do ("Run Application " & Chr(34) & $aWor[$i] & Chr(34))
   $iWins = $oMI.Eval ("NumWindows( )")
   If $iWins Then
	  For $j = 1 To $iWins
		 $iWid = $oMI.Eval ("WindowID(" & $j & ")")
		 If $oMI.Eval ("WindowInfo(" & $iWid & ", 3)") = 3 Then
			$oMI.Do ("PrintWin Window " & $iWid)
		 EndIf
	  Next
   EndIf
   $oMI.Do ("Close All")
   ProgressSet( $i * $progress, $i * $progress & " %")
Next

ProgressSet(100, "  : " & (UBound($awor) - 1), "")
Sleep(5000)
ProgressOff()

$oMI.Do ("End MapInfo")
$oMI = 0